<head>
	{{ omfHeaders }}
	<script src="{{pathPrefix}}/static/highcharts4.src.js"></script>
	<script src="{{pathPrefix}}/static/d3.v3.js"></script>
	<script type="text/javascript">
		function editDSS(modelName, fileName) {
			studyUser = "{{allInputDataDict.user}}"
			window.open("/rawTextEdit/" + studyUser + "/" + modelName + "/" + fileName,  "_blank")
		}
		// Code to make the toggles work:
		$(document).ready(function(){
			$(".toggle").click(function(){
					$(this).parent().next().toggle(500)
			})
		})
	</script>
	{% macro insert_file_upload_block(fileName, dataVariableName) -%}
		<input id="{{dataVariableName}}Handler" type="file" style="display:none" onchange="handle_files(this.files,'{{dataVariableName}}','{{fileName}}')">
		<input id="{{dataVariableName}}" name="{{dataVariableName}}" value="{{allInputDataDict[dataVariableName]}}" type="hidden">
		<div>
			<label for="{{dataVariableName}}Handler" class="fileButton">Choose File</label>
			<input id="{{fileName}}" name="{{fileName}}" value="{{allInputDataDict[fileName]}}" readonly class="uploadFileName">    
		</div>
	{%- endmacro %}
</head>
<body>
	{{ omfModelTitle }}
	<p class="reportTitle">Model Input</p>
	<div id="input" class="content">
		<form name="inputForm" action="/runModel/" onsubmit="event.preventDefault(); return isFormValid();" method="post">
			<div class="shortInput">
				<label>Model Type <a href="https://github.com/dpinney/omf/wiki/Models-~-cyberInverters" target="blank">Help?</a></label>
				<input type="text" id="modelType" name="modelType" value="{{allInputDataDict.modelType}}" readonly/>
			</div>
			<div class="shortInput">
				<label>Model Name</label>
				<input type="text" id="modelName" name="modelName" value="{{allInputDataDict.modelName}}" required="required" pattern="^[\w\s]+$"/></td>
			</div>
			<div class="shortInput">
				<label>Created</label>
				<input type="text" id="created" name="created" value="{{allInputDataDict.created}}" readonly/></td>
			</div>
			<div class="shortInput">
				<label>User</label>
				<input type="text" id="user" name="user" value="{{allInputDataDict.user}}" readonly/></td>
			</div>
			{% if modelStatus == 'finished' %} 
			<div class="shortInput">
				<label>Run Time</label>
				<input type="text" id="runTime" name="runTime" value="{{allInputDataDict.runTime}}" readonly/></td>
			</div>
			{% endif %}
			<div class="wideInput">
				<p class="inputSectionHeader">System Specifications</p>
			</div>
			<hr>
			<div class="shortInput">
				<label>Simulation Start Time (YYYY-MM-DDTHH:mm:SSZ)</label>
				<input type="text" id="simStartDate" name="simStartDate" value="{{allInputDataDict.simStartDate}}" required="required" pattern="^\d\d\d\d-\d\d-\d\dT\d\d:\d\d:\d\d(Z|(\+|-)\d\d:\d\d)$"/>
			</div>
			<div class="shortInput">
				<label class="tooltip">Simulation Timestep Units<span class="classic">The unit of time represented by each row in the 'Load and PV Output' .csv file.</span></label>
				<select id="simStepUnits" name="simStepUnits" value="{{allInputDataDict.simStepUnits}}">
					<option value="hours" {% if allInputDataDict.simStepUnits == 'hours' %}selected{% endif %}>Hours</option>
					<option value="minutes" {% if allInputDataDict.simStepUnits == 'minutes' %}selected{% endif %}>Minutes</option>
					<option value="seconds" {% if allInputDataDict.simStepUnits == 'seconds' %}selected{% endif %}>Seconds</option>
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Simulation Length<span class="classic">Number of timesteps over which the simulation is acting. This number must be less than the number of rows in your load/PV file minus the value entered under "Simulation Entry Point".</span></label>
				<input type="number" id="simLength" name="simLength"  min ="3" max = "14400" value="{{allInputDataDict.simLength}}"/>
			</div>			
			<div class="shortInput">
				<label class="tooltip">Simulation Entry Point<span class="classic">At the beginning of the simulation, the number of timesteps allowed for the powerflow solution to stabilize. Marks the beginning of the experiment (i.e. t=0).</span></label>
				<input type="number" id="simEntryStep" name="simEntryStep" min ="100" max = "9999" value="{{allInputDataDict.simEntryStep}}"/>
			</div>
<!--TODO: make circuitFileNameDSS also update when a file is uploaded through distNetViz-->
			<div class="shortInput">
				<label class="tooltip">Circuit Editor<span class="classic">Use a visual interface to upload, view, and manipulate a .dss circuit file.</span></label>
				<button id="feederButton" type="button" onclick="editFeeder('{{allInputDataDict.modelName}}',1)" style="display:block;width:125px;">Open Editor</button>
			</div>
			<div class="shortInput" style="display:none"><!--HACK:pass feeder name back and forth to backend.-->
				<input type="text" id="feederName1" name="feederName1" value="{{allInputDataDict.feederName1}}">
			</div>
<!--TODO: make feederName1 also update when a file is uploaded through distText-->
			<!--<div class="shortInput">
				<label class="tooltip">Circuit Editor - Text<span class="classic">Manipulate a .dss circuit file directly in the definition file.</span></label>
				<button id="OpenDSSButton" type="button" onclick="editDSS('{{allInputDataDict.modelName}}','{{allInputDataDict.circuitFileNameDSS}}')" style="display:block;width:125px;">Open Editor</button>
			</div>
			<div class="shortInput" style="display:none">
				<input type="text" id="circuitFileNameDSS" name="circuitFileNameDSS" value="{{allInputDataDict.circuitFileNameDSS}}">
			</div>-->
			<div class="shortInput">
				<label class="tooltip">Load and PV Output<span class="classic">Import a .csv file that describes the power output of all loads and PV units.</span></label>
				<div>{{ insert_file_upload_block('loadPVFileName','loadPVFileContent') }}</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Breakpoints File Input<span class="classic">Import a .csv file containing the breakpoints that describe the volt-var curve of each inverter.</span></label>
				<div>{{ insert_file_upload_block('breakpointsFileName','breakpointsFileContent') }}</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Miscellaneous File Input<span class="classic">Import a .csv file that contains hyperparameters for the model. </span></label>
				<div>{{ insert_file_upload_block('miscFileName','miscFileContent') }}</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Battery File Input<span class="classic">Import a .csv file that describes the characteristics of the battery energy storage system.</span></label>
				<div>{{ insert_file_upload_block('storageFileName','storageFileContent') }}</div>
			</div>
			<div class="shortInput">
				<label class="tooltip">Include Battery?<span class="classic">Select whether or not to include batteries on the circuit.</span></label>
				<select id="includeBattery" name="includeBattery" value="{{allInputDataDict.includeBattery}}">
					<option value="True" {% if allInputDataDict.includeBattery == 'True' %}selected{% endif %}>Yes</option>
					<option value="False" {% if allInputDataDict.includeBattery == 'False' %}selected{% endif %}>No</option>
				</select>
			</div>
			<div class="wideInput">
				<p class="inputSectionHeader">Cyber Attack Specifications</p>
			</div>
			<hr>
			<div class="shortInput">
				<label class="tooltip">Attack Agent Variable<span class="classic">Select the type of attack to occur.</span></label>
				<select id="attackVariable" name="attackVariable" value="{{allInputDataDict.attackVariable}}">
					<option value="None" {% if allInputDataDict.attackVariable == 'None' %}selected{% endif %}>None</option>
					<option value="Voltage Oscillation" {% if allInputDataDict.attackVariable == 'Voltage Oscillation' %}selected{% endif %}>Voltage Oscillation</option>
					<option value="Voltage Imbalance" {% if allInputDataDict.attackVariable == 'Voltage Imbalance' %}selected{% endif %}>Voltage Imbalance</option>
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Attack Agent Entry Point<span class="classic">The severity of attack represented by percentage</span></label>
				<input type="number" id="hackStart" name="hackStart"  value="{{allInputDataDict.hackStart}}"/>
			</div>
			<div class="shortInput">
				<label class="tooltip">Attack Agent Exit Point<span class="classic">The severity of attack represented by percentage</span></label>
				<input type="number" id="hackEnd" name="hackEnd"  value="{{allInputDataDict.hackEnd}}"/>
			</div>
			<div class="shortInput">
				<label class="tooltip">Hack Percentage<span class="classic">The severity of attack represented by percentage</span></label>
				<input type="number" id="hackPercent" name="hackPercent" min ="0" max = "100" value="{{allInputDataDict.hackPercent}}"/>
			</div>
			<div class="shortInput">
				<label class="tooltip">Defense Agent Variable<span class="classic">Select trained defense agent from the list, or select 'None' and run a training simulation to create one.</span></label>
				<input id="defenseAgentNames" name="defenseAgentNames" type="hidden"/>
				<select id="defenseVariable" name="defenseVariable" value="{{allInputDataDict.defenseVariable}}">
					<option value="None" {% if allInputDataDict.defenseVariable == 'None' %}selected{% endif %}>None</option>
					{% for agentFolderName in allInputDataDict["defenseAgentNames"].split(",") %}
						<option value="{{agentFolderName}}" {% if allInputDataDict.defenseVariable == '{{agentFolderName}}' %}selected{% endif %}>{{agentFolderName}}</option>
					{% endfor %}
				</select>
			</div>
			<div class="shortInput">
				<label class="tooltip">Train?<span class="classic">Select whether or not to train the defense agent.</span></label>
				<select id="trainAgent" name="trainAgent" value="{{allInputDataDict.trainAgent}}">
					<option value="True" {% if allInputDataDict.trainAgent == 'True' %}selected{% endif %}>Yes</option>
					<option value="False" {% if allInputDataDict.trainAgent == 'False' %}selected{% endif %}>No</option>
				</select>
			</div>
			{{ omfModelButtons }}
		</form>
		<div> PyCigar commit 42b66d1 </div>
	</div>
	{{ omfRunDebugBlock }}
	{% if modelStatus == 'finished' %}
	<div id="output">
		<script>
			// Global setting of Highcharts
			Highcharts.setOptions({global: {useUTC: true}})
			// Clean up the non-ISO date strings we get.
			function dateOb(inStr) {return Date.parse(inStr.replace(/-/g,"/"))}
			pointStart = dateOb("{{allOutputDataDict.timeStamps[0]}}")
			pointInterval = dateOb("{{allOutputDataDict.timeStamps[1]}}") - pointStart
			highChartsTemplate = {
				"chart":{"renderTo":"", "marginRight":20, "marginBottom":35, "zoomType":"x", "width":1000, "height":150},
				"title":{"text":null},
				"legend":{"layout":"horizontal", "align":"top", "verticalAlign":"top", "x":50, "y":-10, "borderWidth":0},
				"credits":{"enabled":false},
				"xAxis":{"showEmpty": false, "type":"datetime","maxZoom":1000, "tickColor":"gray","lineColor":"gray"},
				"yAxis":{"showEmpty": false, "title":{"text":null, "style":{"color":"gray"}}},
				"plotOptions":{"line":{"marker":{"enabled":false}}, "series":{"shadow":false, "pointInterval":pointInterval, "pointStart":pointStart}},
				"tooltip":{"valueDecimals":1},
				"series":[]}
		</script>
		<p class="reportTitle">Energy Balance <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="newEnergyBalanceReport" class="tightContent">
			<script type="text/javascript">
				function arrSum(arr) {
					myVal = eval(arr.join("+"))
					if (typeof myVal == "undefined") {return 0} else {return myVal}
				}
				tPower = eval({{allOutputDataDict.Consumption.Power}}.join("+"))
				tLosses = eval({{allOutputDataDict.Consumption.Losses}}.join("+"))
				tDG = eval({{allOutputDataDict.Consumption.DG}}.join("+"))
				tLoads = tPower + tDG - tLosses
				dgExported = []
				fromGrid = []
				for (i = 0; i < {{allOutputDataDict.Consumption.Power}}.length; i++) {
					curVal = {{allOutputDataDict.Consumption.Power}}[i]
					if (curVal < 0) {dgExported.push(curVal)} else {fromGrid.push(curVal)}
				}
				tDGExported = arrSum(dgExported)
				tFromGrid = arrSum(fromGrid)
				tDGDirect = tLoads + tLosses - tFromGrid
				// Series formatting.
				tLossesSeries = {
					"pointWidth": 40,  
					"color":"orangered", 
					"data":[0,tLosses], 
					"type":"bar", 
					"name":"Losses"
				}
				tLoadsSeries = {
					"pointWidth": 40, 
					"color":"darkorange", 
					"data":[0,tLoads], 
					"type":"bar", 
					"name":"Loads"
				}
				tDGSeries = {
					"pointWidth": 40, 
					"color":"seagreen", 
					"data":[tDG], 
					"type":"bar", 
					"name":"Generated"
				}
				tFromGridSeries = {
					"pointWidth": 40,  
					"color":"crimson", 
					"data":[tFromGrid,0], 
					"type":"bar", 
					"name":"Imported"
				}
				tDGDirectSeries = {
					"pointWidth": 40, 
					"color":"RoyalBlue", 
					"data":[tDGDirect,0], 
					"type":"bar", 
					"name":"DG Direct Use"
				}
				tDGExportedSeries = {
					"pointWidth": 40, 
					"color":"LightSeaGreen", 
					"data":[tDGExported,0], 
					"type":"bar", 
					"name":"DG Exported"
				}
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "newEnergyBalanceReport"
				localHighChart["chart"]["inverted"] = false
				localHighChart["chart"]["height"] = 250
				localHighChart["chart"]["marginBottom"] = 50
				localHighChart["series"] = [tFromGridSeries,tDGDirectSeries,tDGExportedSeries,tLossesSeries,tLoadsSeries]
				localHighChart["xAxis"] = {
					"categories":["Source","Destination"]
					}
				localHighChart["yAxis"] = {
					"title": {
						"text": 'Energy (Wh)',
						//"offset":20
					}
				}
				localHighChart["plotOptions"] = {
					"bar":{"stacking":"normal"},
				}
				new Highcharts.Chart(localHighChart)
			</script>
		</div>
		<p class="reportTitle">Power Consumption From Transmission System <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="powerConsumptionReport" class="tightContent">
			<div id="powerTimeSeries"></div>
			<script>
				// power series data
				power = {{allOutputDataDict.Consumption.Power}}
				losses = {{allOutputDataDict.Consumption.Losses}}
				dg = {{allOutputDataDict.Consumption.DG}}
				powerSeries = {
					"marker":{"enabled":false},
					"color":"crimson",
					"data":power,
					"name":"Substation Powerflow (W)"}
				lossesSeries = {
					"marker":{"enabled":false},
					"color":"orangered",
					"data":losses,
					"name":"Technical Losses (W)",
					"visible":false}
				DGSeries = {
					"marker":{"enabled":false},
					"color":"darkturquoise",
					"data":dg,
					"name":"DG Power (W)",
					"visible":false}
				var localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "powerTimeSeries"
				localHighChart["chart"]["type"] = "line"
				localHighChart["series"] = [powerSeries, lossesSeries, DGSeries]
				localHighChart["yAxis"] = [{
					"title":{"text":"Power (W)"},
				}]
				new Highcharts.Chart(localHighChart);
			</script>
		</div>
		<p class="reportTitle">Transmission Voltage <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="swingVoltageReport" class="tightContent">
			<div id="voltageTimeSeries"></div>
			<script type="text/javascript">
				swingVoltage = {{allOutputDataDict.swingVoltage}}
				downlineNodeVolts = {{allOutputDataDict.downlineNodeVolts}}
				var swingVoltageSeries = {
					"marker":{"enabled":false},
					"color":"blue",
					"data":swingVoltage,
					"name":"Transmission Voltage (PU)",
					"visible":true
				}
				var downlineNodeVoltsSeries = {
					"marker":{"enabled":false},
					"color":"orange",
					"data":downlineNodeVolts,
					"name":"Voltage at First Node after Regulator (PU)",
					"visible":true
				}
				var localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "voltageTimeSeries"
				localHighChart["chart"]["type"] = "line"
				localHighChart["series"] = [swingVoltageSeries, downlineNodeVoltsSeries]
				localHighChart["tooltip"]["valueDecimals"] = 3
				localHighChart["yAxis"]= [{
					"title":{"text":"Voltage (PU)"},
					"plotLines":[{
						"color":'gray', 
						"dashStyle":'ShortDash', 
						"width":2, 
						"value":114
					},{
						"color":'gray', 
						"dashStyle":'ShortDash', 
						"width":2, 
						"value":126
					}]
				}]
				new Highcharts.Chart(localHighChart);
			</script>
		</div>
		<p class="reportTitle">Substation Power Factor <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="substationPowerFactorReport" class="tightContent">
			<div id="powerFactorTimeSeries"></div>
			<script type="text/javascript">
				swingPf = {{allOutputDataDict.powerFactor}}
				var swingPfSeries = {
					"marker":{"enabled":false},
					"color":"blue",
					"data":swingPf,
					"name":"Power Factor",
					"visible":true
				}
				var localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "powerFactorTimeSeries"
				localHighChart["chart"]["type"] = "line"
				localHighChart["series"] = [swingPfSeries]
				localHighChart["tooltip"]["valueDecimals"] = 3
				localHighChart["yAxis"]= [{
					"title":{"text": "Power Factor"},
					"min": -1,
					"max": 1,
					"tickPositions": [-1,1],
					"startOnTick": false,
					"endOnTick": false
				}]
				new Highcharts.Chart(localHighChart);
			</script>
		</div>
		<p class="reportTitle">Regulator Tap Changes <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="newRegulatorReport" class="tightContent" style="max-height:610px; overflow-y: scroll;">
			{% if allOutputDataDict.Regulator_Outputs|length == 0 %}
			<script type="text/javascript">	
				$("#newRegulatorReport").html("<p>&#160;&#160;&#160;No regulators were found on the feeder.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">
			for (let [regname, regitems] of Object.entries({{allOutputDataDict.Regulator_Outputs|tojson}})) {
				$("<div/>").appendTo("#newRegulatorReport")
					.attr("class", "regContainer")
					.attr("id", regname)
				$("<div/>").appendTo("#newRegulatorReport")
					.attr("id", "regulatorSeries_" + regname)
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "regulatorSeries_" + regname
				localHighChart["chart"]["type"] = "line"
				localHighChart["tooltip"]["valueDecimals"] = 0
				localHighChart["title"]["text"] = regname
				localHighChart["title"]["align"] = "right"
				localHighChart["title"]["x"] = -50
				localHighChart["series"] = []
				localHighChart["yAxis"] = {
					"min":-17, 
					"max":17,
					"startOnTick":false,
					"endOnTick":false,
					"tickPositions":[-16,16],
					"title":{"text":"Tap Position"}
				}
				for (let [phs, dat] of Object.entries(regitems["tapchanges"])) {
					if (phs=='C') {
						color = "Seagreen"
					} else if (phs=='B') {
						color = "Crimson"
					} else {
						color = "RoyalBlue"
					}
					localHighChart["series"].push({
						"pointWidth": 40,
						"data": dat,
						"name": phs,
						"color": color,
					})
				}
				new Highcharts.Chart(localHighChart)
			}
			</script>
		</div>
		<p class="reportTitle">Cap Bank Activation <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="newCapbankReport" class="tightContent" style="max-height:610px; overflow-y: scroll;">
			{% if allOutputDataDict.Capacitor_Outputs|length == 0 %}
			<script type="text/javascript">	
				$("#newCapbankReport").html("<p>&#160;&#160;&#160;No capacitors were found on the feeder.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">
			for (let [capname, capitems] of Object.entries({{allOutputDataDict.Capacitor_Outputs|tojson}})) {
				$("<div/>").appendTo("#newCapbankReport")
					.attr("class", "capContainer")
					.attr("id", capname)
				$("<div/>").appendTo("#newCapbankReport")
					.attr("id", "capacitorSeries_" + capname)
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "capacitorSeries_" + capname
				localHighChart["chart"]["inverted"] = false
				localHighChart["chart"]["type"] = "line"
				localHighChart["title"]["text"] = capname
				localHighChart["series"] = []
				localHighChart["yAxis"] = {
					"min":-17, 
					"max":17,
					"startOnTick":false,
					"endOnTick":false,
					"tickPositions":[-16,16],
					"title":{"text":"Tap Position"}
				}
				for (let [phs, dat] of Object.entries(capitems["tapchanges"])) {
					if (phs=='C') {
						color = "Seagreen"
					} else if (phs=='B') {
						color = "Crimson"
					} else {
						color = "RoyalBlue"
					}
					localHighChart["series"].push({
						"pointWidth": 40,
						"data": dat,
						"name": phs,
						"color": color,
					})
				}
				new Highcharts.Chart(localHighChart)
			}
			</script>
		</div>
		<p class="reportTitle">Triplex Meter Imbalances <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="voltageImbalancesReport" class="tightContent">
			{% if allOutputDataDict.voltageImbalances|length == 0 %}
			<script type="text/javascript">	
				$("#voltageImbalancesReport").html("<p>&#160;&#160;&#160;No voltage imbalance values were returned.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">	
			localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
			localHighChart["chart"]["renderTo"] = "voltageImbalancesReport"
			localHighChart["chart"]["height"] = 200
			localHighChart["chart"]["type"] = "line"
			localHighChart["yAxis"] = {"title":{"text":"Imbalance (%)"}}
			for (let [busName,imbalseries] of Object.entries({{allOutputDataDict.voltageImbalances}})) {
				localHighChart["series"].push({
					"marker": {"enabled":false}, 
					"color": "rgba(128,128,128,0.15)",
					"data": imbalseries.map(x => 100 * x), 
					"name": busName,
				})
			}
			new Highcharts.Chart(localHighChart)
			</script>
		</div>
		<p class="reportTitle">Triplex Meter Voltage Summary <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="triplexMeterVoltageReport" class="tightContent">
			<div id="triplexMeterVoltageChart"></div>
			<script type="text/javascript">
				triplexMin = {
					"marker": {"enabled":false}, 
					"color":"skyblue", 
					"data":{{allOutputDataDict.allMeterVoltages.Min}}, 
					"name":"Min"
				}
				triplexMean = {
					"marker":{"enabled":false}, 
					"color":"royalblue", 
					"data":{{allOutputDataDict.allMeterVoltages.Mean}}, 
					"name":"Mean"
				}
				triplexMax = {
					"marker":{"enabled":false}, 
					"color":"steelblue", 
					"data":{{allOutputDataDict.allMeterVoltages.Max}}, 
					"name":"Max"
				}
				var localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "triplexMeterVoltageChart"
				localHighChart["chart"]["height"] = 200
				localHighChart["chart"]["type"] = "line"
				localHighChart["series"] = [triplexMin,triplexMean,triplexMax]
				localHighChart["yAxis"] = {
					"maxRange":20,
					"title":{"text":"Voltage (V)"},
					"plotLines":[{
						"color":'gray', 
						"dashStyle":'ShortDash', 
						"width":2, 
						"value":114, 
					},{
						"color":'gray',
						"dashStyle":'ShortDash',
						"width":2, 
						"value":126, 
					}],
				}
				new Highcharts.Chart(localHighChart)
			</script>
		</div>
		<p class="reportTitle">Triplex Meter Voltage Detail <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="voltageImbalancesByBusReport" class="tightContent" style="max-height:610px; overflow-y: scroll;">
			{% if allOutputDataDict.Bus_Voltages|length == 0 %}
			<script type="text/javascript">	
				$("#voltageImbalancesByBusReport").html("<p>&#160;&#160;&#160;No bus voltage imbalance values were returned.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">
			for (let [busName,phsVolts] of Object.entries({{allOutputDataDict.Bus_Voltages|tojson}})) {
				$("<div/>").appendTo("#voltageImbalancesByBusReport")
					.attr("class", "busContainer")
					.attr("id", busName)
				$("<div/>").appendTo("#voltageImbalancesByBusReport")
					.attr("id", "busSeries_" + busName)
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "busSeries_" + busName
				localHighChart["chart"]["zoomType"] = 'xy'
				localHighChart["chart"]["height"] = 200
				localHighChart["chart"]["marginRight"] = 150
				localHighChart["chart"]["type"] = "line"
				localHighChart["title"]["text"] = busName
				localHighChart["title"]["align"] = "right"
				localHighChart["title"]["x"] = -50
				localHighChart["tooltip"]["valueDecimals"] = 3
				localHighChart["yAxis"] = [{
						"title": {"text": "Voltage (V)","style": {"color":"gray"}}
					}]
				for (let [phs, dat] of Object.entries(phsVolts)) {
				if (phs=='C') {
					color = "Seagreen"
				} else if (phs=='B') {
					color = "Crimson"
				} else {
					color = "RoyalBlue"
				}
				localHighChart["series"].push({
						"pointWidth": 40,
						"data": dat,
						"name": phs,
						"color": color,
					})
				}
				new Highcharts.Chart(localHighChart)
			}
			</script>
		</div>
		<p class="reportTitle">Inverter Outputs <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="newInverterReport" class="tightContent" style="max-height:610px; overflow-y: scroll;">
			{% if allOutputDataDict.Inverter_Outputs|length == 0 %}
			<script type="text/javascript">	
				$("#newInverterReport").html("<p>&#160;&#160;&#160;No inverters were found on the feeder.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">
			for (let [invname, invitems] of Object.entries({{allOutputDataDict.Inverter_Outputs|tojson}})) {
				invVoltage = invitems["Voltage"]
				invPowerReal = invitems["Power_Real"]
				invPowerImag = invitems["Power_Imag"]
				realPowerMin = Math.min(...invPowerReal)
				realPowerMax = Math.max(...invPowerReal)
				imagPowerMin = Math.min(...invPowerImag)
				imagPowerMax = Math.max(...invPowerImag)
				voltageMin = Math.min(...invVoltage)
				voltageMax = Math.max(...invVoltage)
				yPowerMin = 0
				yPowerMax = 0
				if (realPowerMin <= imagPowerMin){
					yPowerMin = realPowerMin
				}
				else{
					yPowerMin = imagPowerMin
				}
				if (realPowerMax >= imagPowerMax){
					yPowerMax = realPowerMax
				}
				else{
					yPowerMax = imagPowerMax
				}
				yPowerMin = Math.floor(yPowerMin/100)*100
				yPowerMax = Math.ceil(yPowerMax/100)*100

				$("<div/>").appendTo("#newInverterReport")
					.attr("class", "inverterContainer")
					.attr("id", invname)
				$("<div/>").appendTo("#newInverterReport")
					.attr("id", "inverterSeries_" + invname)
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "inverterSeries_" + invname
				localHighChart["chart"]["zoomType"] = 'xy'
				localHighChart["chart"]["height"] = 200
				localHighChart["chart"]["marginRight"] = 80
				localHighChart["chart"]["type"] = "line"
				localHighChart["title"]["text"] = invname
				localHighChart["title"]["align"] = "right"
				localHighChart["title"]["x"] = -50
				localHighChart["yAxis"] = [{
						"min":voltageMin,
						"max":voltageMax,
						"title":{"text": "Voltage (V)"},
					}, {
						"min":yPowerMin, 
						"max":yPowerMax,
						"title":{"text":"Power (W or VAR)"},
						"opposite":true,
					}]
				localHighChart["series"] = [{
					"pointWidth":40,
					"color":"RoyalBlue",
					"data":invVoltage,
					"name":"Voltage"
				},{
					"pointWidth": 40,
					"color":"crimson",
					"data":invPowerReal,
					"name":"Real Power Output",
					"yAxis":1
				},{
					"pointWidth": 40,
					"color":"orange",
					"data":invPowerImag,
					"name":"Reactive Power Output",
					"yAxis":1
				}]
				new Highcharts.Chart(localHighChart)
			}
			</script>
		</div>
		<p class="reportTitle">Battery Outputs <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="batteryReport" class="tightContent" style="max-height:610px; overflow-y: scroll;">
			{% if allOutputDataDict.Battery_Outputs|length == 0 %}
			<script type="text/javascript">	
				$("#batteryReport").html("<p>&#160;&#160;&#160;No battery storage units were found on the feeder.</p>")
			</script>
			{% endif %}
			<script type="text/javascript">	
			//var dodFactor = parseFloat(allInputData.dodFactor) //We need an output for this from pyCigar, as it will be contained in the battery control spec
			dodFactor = 90 // hardcode allowable discharge
			for (let [battName, battDat] of Object.entries({{allOutputDataDict.Battery_Outputs|tojson}})) {
				battSOC = battDat["SOC"]
				battStatus = battDat["Charge_Status"]
				battCycles = battDat["Cycles"]
				battPower = battDat["Power"]
				minPower = Math.min(...battPower)
				maxPower = Math.max(...battPower)
				$("<div/>").appendTo("#batteryReport")
					.attr("class", "batteryContainer")
					.attr("id", battName)
				$("<div/>").appendTo("#batteryReport")
					.attr("id", "batterySeries_" + battName)
				localHighChart = JSON.parse(JSON.stringify(highChartsTemplate))
				localHighChart["chart"]["renderTo"] = "batterySeries_" + battName
				localHighChart["chart"]["zoomType"] = 'xy'
				localHighChart["chart"]["inverted"] = false
				localHighChart["chart"]["height"] = 200
				localHighChart["chart"]["marginRight"] = 120
				localHighChart["chart"]["type"] = "line"
				localHighChart["title"]["text"] = battName
				localHighChart["title"]["align"] = "right"
				localHighChart["title"]["x"] = -50
				localHighChart["yAxis"] = [{
					"title":{"text":"Power (W)"},
					"min":minPower, 
					"max":maxPower,
				},{
					"title":{"text":"SoC (%)"},
					"min":0, 
					"max":100,
					"opposite": true,
					"tickPositions":[0,25,50,75,100],
					"plotLines":[{
						"color":"gray",
						"dashStyle":"ShortDash",
						"width":2,
						"label":{
							"text":"Max DOD:" + dodFactor + "%",
							"align":"left",
							"x":-5,
							"style":{"color":"gray", "fontsize":"12px"}
							},
						"value": 100-dodFactor,
					},{
						"color":"gray",
						"dashStyle":"ShortDash",
						"width":1,
						"label":{
							"text":"Cycle Equivalents: " + delimitNumbers(battCycles.toFixed(1)), 
							"align":"right",
							"x":-5,
							"style":{"color":"gray", "fontsize":"12px"}
							},
						"value": 100-dodFactor,
					}]
				},{
					"title":{"text":"Status"},
					"categories":["discharge", "standby", "charge"],
					"min":0,
					"max":2,
					"endOnTick": false,
					"startOnTick": false,
					"opposite":true
				}]
				localHighChart["series"] = [{
					"name":"Power Output",
					"pointWidth": 40,
					"color":"crimson",
					"data": battPower,
					"yAxis": 0,
				},{
					"name":"State of Charge",
					"pointWidth": 40,
					"color":"royalblue",
					"data": battSOC,
					"yAxis": 1
				},{
					"name":"Control Status",
					"pointWidth": 40,
					"color":"lightseagreen",
					"data": battStatus,
					"visible":false,
					"yAxis": 2
				}]
				new Highcharts.Chart(localHighChart);
			}					
			</script>
		</div>
		<p class="reportTitle">Solar Data <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="irradianceReport" class="tightContent">
			<div id="irradianceChartDiv"></div>
				<p>&#160;&#160;&#160;No solar data inputs. Inverter outputs defined explicitly.</p>
			<!-- <script>
				irradianceSeriesData = [
					{"name":'Global Horizontal',"marker":{"enabled":false},"color":"gold","data":allOutputData.climate['Global Horizontal (W/sm)'],"visible":true}]
				new Highcharts.Chart({
					"credits":{"enabled":false},
					"plotOptions":{
						"series":{"animation": false, "pointStart":pointStart,"shadow":false,"pointInterval":pointInterval},
						"line":{"marker":{"enabled":true}}},
					"xAxis":{"maxZoom":1000,"tickColor":"gray","type":"datetime","lineColor":"gray"},
					"title":{"text":null},
					"series":irradianceSeriesData,
					"yAxis":{"title":{"text":"Irradiance ( W / m^2 )","style":{"color":"gray"}}, "min":0},
					"chart":{"marginBottom":35,"zoomType":"x","renderTo":"irradianceChartDiv","type":"line","marginRight":20, "height":300,"width":1000},
					"tooltip":false,
					"legend":{"verticalAlign":"top","align":"top","borderWidth":0,"x":50,"y":-10,"layout":"horizontal"}})
			</script> -->
		</div>
		<!-- <p class="reportTitle">Study Details <a target="_self" class="toggle">Hide / Show</a></p>
		<div id="studyDetails" class="tightContent detailsContainer" style="position: relative;">
			<div id="mapHere" style="width:495px; height:340px; display:inline-block"></div>
			<script type="text/javascript">
				width = 495, height = 340
				projection = d3.geo.albersUsa().scale(600).translate([width/2, height/2])
				path = d3.geo.path()
					.projection(projection)
				svg = d3.select("#mapHere").append("svg")
					.attr("width", width)
					.attr("height", height)
				group = svg.append("g")
				group.attr("transorm", "scale(.2, .2)")
				d3.json("{{pathPrefix}}/static/state_boundaries.json", function(collection) {
					group.selectAll('path')
						.data(collection.features)
						.enter().append('path')
						.attr('d', d3.geo.path().projection(projection))
						.attr('id', function(d){return d.properties.name.replace(/\s+/g, '')})
						.style('fill', 'gray')
						.style('stroke', 'white')
						.style('stroke-width', 1)})
				d3.json("{{pathPrefix}}/static/city_locations.json", function(new_us_places){
					climate = allInputData.climateName
					ST_NAME = climate.split("-")
					ST = ST_NAME[0]
					NAME = ST_NAME[1].replace("_"," ")
					my_coords = projection(new_us_places[ST][NAME])
					r = 5
					circle = svg.append("circle")
						.attr("cx", my_coords[0])
						.attr("cy", my_coords[1])
						.attr("r", 5)
						.attr("class", "HighlightCircle")
					circle.append("svg:title").text(climate)})
			</script>
			<div id="runtimeStatsReport" style="width:495px; height:340px; margin:5 0 0 0; overflow-y:scroll; overflow-x:hidden; display:inline-block; vertical-align:top">
				<pre id="stdout" style="font-size:13px; text-align:left"></pre>
			</div>
			<script>gebi("stdout").innerHTML = allOutputData.stdout</script>
		</div> -->
<!-- 		<p class="reportTitle">Study Details and Standard Output<a target="_self" class="toggle">Hide / Show</a></p>
		<div id="studyDetails" class="tightContent detailsContainer" style="position: relative;">
			<div id="runtimeStatsReport" style="width:100%; height:340px; margin:5 0 0 0; overflow-y:scroll; overflow-x:hidden; display:inline-block; vertical-align:top">
				<pre id="stdout" style="font-size:13px; text-align:left"></pre>
			</div>
			<script>gebi("stdout").innerHTML = allOutputData.stdout</script>
		</div> -->
		{{rawOutputFiles}}
	</div>
	{% endif %}
</body>